{ -----------------------------------------------------
  DBNavEdit.pas

  Copyright (c) 1999, Walter Alves Chagas Junior
  URL: http://www.geocities.com/SiliconValley/Bay/1058)
  Mail: wchagas@horizontes.net

  DBNavEdit Component v1.0,
  descendente do TDBEdit permite que voce, usando as teclas
  PageUp/PgDow ou setas p/cima e p/baixo, trafegue para o proximo
  registro ou para o anterior.

  ----------------------------------------------------- }
unit DBNavEdit;

interface

uses
  WinProcs, WinTypes, Messages, SysUtils, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Mask, DBCtrls, Db;

type
  TDBNavEdit = class(TDBEdit)
  private
    parentHwnd: HWND;
  protected
    procedure WMKeyDown (var Msg: TMessage); message WM_KEYDOWN;
  public
    constructor Create (AOwner: TComponent); override;
  end;

procedure Register;

implementation


constructor TDBNavEdit.Create(AOwner: TComponent);
begin
inherited Create(AOwner);
parentHwnd := (AOwner as TForm).Handle;
end;

procedure TDBNavEdit.WMKeyDown (var Msg: TMessage);
var
VirtKey: integer;
begin
inherited;
VirtKey := Msg.wParam;
with (DataSource.DataSet) do
     begin
     if (VirtKey = VK_RETURN) or (VirtKey = VK_DOWN) then
        begin
        if (State = dsEdit) or (State = dsInsert) then
           begin
           Post;
           end;
        PostMessage (parentHwnd, WM_NEXTDLGCTL, 0, 0);
        end
     else if (VirtKey = VK_UP) then
             begin
             if (State = dsEdit) or (State = dsInsert) then
                begin
                Post;
                end;
             PostMessage (parentHwnd, WM_NEXTDLGCTL, 1, 0);
             end
     else if (VirtKey = VK_NEXT) then
             begin
             if (GetKeyState (VK_CONTROL) < 0) then
                begin 
                Last;
                end 
             else
                begin
                Next;
                end;
             if (EOF) then
                begin
                Insert;
                end;
             end
     else if (VirtKey = VK_PRIOR) then
          begin
          if (GetKeyState (VK_CONTROL) < 0) then
             begin 
             First;
             end
          else
             begin
             if (State = dsInsert) then
                begin  
                Last;
                end
             else
                begin
                Prior;
                end;
             end;
          end;
     end;
end;

procedure Register;
begin
RegisterComponents('Data Controls', [TDBNavEdit]);
end;

end.
